Package net.sf.saxon.xpath

## Class XPathFunctionLibrary

- java.lang.Object
- - net.sf.saxon.xpath.XPathFunctionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`

      public class XPathFunctionLibrary
      extends java.lang.Object
      implements FunctionLibrary

  The XPathFunctionLibrary is a FunctionLibrary that supports binding of XPath function calls to instances of the JAXP XPathFunction interface returned by an XPathFunctionResolver.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XPathFunctionLibrary()` | Construct a XPathFunctionLibrary

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `Function` | `getFunctionItem​(SymbolicName.F symbolicName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `javax.xml.xpath.XPathFunctionResolver` | `getXPathFunctionResolver()` | Get the resolver
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available
    `void` | `setXPathFunctionResolver​(javax.xml.xpath.XPathFunctionResolver resolver)` | Set the resolver

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### XPathFunctionLibrary

          public XPathFunctionLibrary()

      Construct a XPathFunctionLibrary

  - ### Method Detail

    - #### setXPathFunctionResolver

          public void setXPathFunctionResolver​(javax.xml.xpath.XPathFunctionResolver resolver)

      Set the resolver
      Parameters:
        `resolver` - The XPathFunctionResolver wrapped by this FunctionLibrary

    - #### getXPathFunctionResolver

          public javax.xml.xpath.XPathFunctionResolver getXPathFunctionResolver()

      Get the resolver
      Returns:
        the XPathFunctionResolver wrapped by this FunctionLibrary

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - The name of the function
        `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
        `env` - The static context
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F symbolicName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `symbolicName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.